# Version 1.0
import time
import threading
import logging

class RepeatedTimer(object):
    def __init__(self, interval, function, *args, **kwargs):
        #logging.info("Init RepeatedTimer = {}".format(interval))
        self._timer = None
        self.interval = interval
        self.function = function
        self.args = args
        self.kwargs = kwargs
        self.is_running = False
        self.next_call = time.time()

    def _run(self):
        #logging.info("Run RepeatedTimer")
        self.is_running = False
        self.start()
        self.function(*self.args, **self.kwargs)
        #logging.info("Ejecutando= {}".format(time.strftime('%Y-%m-%d %H:%M:%S', time.localtime())))

    def start(self):
        #logging.info("start is_running={}".format(self.is_running))
        if not self.is_running:
            self.next_call = time.time() + self.interval
            #logging.info("Next call= {} {}".format(time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(self.next_call)), self.next_call))
            self._timer = threading.Timer(self.next_call - time.time(), self._run)
            self._timer.start()
            self.is_running = True

    def stop(self):
        #logging.info("stop is_running={}".format(self.is_running))
        if self.is_running:
            #logging.info("Stopping timer")
            self._timer.cancel()
            self.is_running = False
